import { Gateway, GatewayConfiguration, Methods, Mode } from "./gateway";
import Redis, { RedisOptions } from "ioredis";
export interface BlackListItem {
    id: string;
    timestamp: number;
}
export declare type PaymentMethods = {
    [Key in Methods]?: GatewayConfiguration;
};
export interface ManagerOptions {
    redis?: Redis | RedisOptions;
}
export declare class GatewayManager {
    protected PaymentMethods: PaymentMethods;
    protected Options: ManagerOptions;
    ExecutedBlacklist: BlackListItem[];
    Redis?: Redis;
    protected blacklistPaymentID: (id: string, time?: number) => Promise<this>;
    protected paymentIsExecuted: (id: string) => Promise<boolean>;
    protected unBlacklistPaymentID: (id: string) => Promise<this>;
    constructor(PaymentMethods: PaymentMethods, Options?: ManagerOptions);
    listMethods: (currency?: string) => Methods[];
    get: <T extends Methods>(method: T, mode?: Mode) => Gateway<T>;
}
