import { Mode, Gateway, Methods } from "../../gateway";
import { Stripe } from "stripe";
import { Items } from "../../items";
export interface CheckoutConfiguration {
    methods?: Stripe.Checkout.SessionCreateParams.PaymentMethodType[];
    returnUrl: string;
    cancelUrl: string;
}
export interface ExecuteOptions {
    paymentId: string;
    payerId?: string;
}
export interface CreateIntentResponse {
    method: Methods;
    mode: Mode;
    key: string;
    response: Stripe.Response<Stripe.Checkout.Session>;
    checkoutUrl: string | null;
}
export interface ExecuteIntentResponse {
    method: Methods;
    mode: Mode;
    details: {
        currency: string;
        amount: number;
    };
    response: Stripe.Response<Stripe.Checkout.Session>;
}
export declare const EpicStripePaymentsOneTime: (Parent: Gateway<"Stripe">) => {
    new (configuration?: CheckoutConfiguration): {
        Instance: Stripe;
        Configuration?: CheckoutConfiguration | undefined;
        configure: (configuration: CheckoutConfiguration) => any;
        create: (Items: Items<"One-Time">, custom?: {
            cancel_url?: string | undefined;
            success_url?: string | undefined;
            after_expiration?: Stripe.Checkout.SessionCreateParams.AfterExpiration | undefined;
            allow_promotion_codes?: boolean | undefined;
            automatic_tax?: Stripe.Checkout.SessionCreateParams.AutomaticTax | undefined;
            billing_address_collection?: Stripe.Checkout.SessionCreateParams.BillingAddressCollection | undefined;
            client_reference_id?: string | undefined;
            consent_collection?: Stripe.Checkout.SessionCreateParams.ConsentCollection | undefined;
            customer?: string | undefined;
            customer_email?: string | undefined;
            customer_update?: Stripe.Checkout.SessionCreateParams.CustomerUpdate | undefined;
            discounts?: Stripe.Checkout.SessionCreateParams.Discount[] | undefined;
            expand?: string[] | undefined;
            expires_at?: number | undefined;
            line_items?: Stripe.Checkout.SessionCreateParams.LineItem[] | undefined;
            locale?: Stripe.Checkout.SessionCreateParams.Locale | undefined;
            metadata?: Stripe.MetadataParam | undefined;
            mode?: Stripe.Checkout.SessionCreateParams.Mode | undefined;
            payment_intent_data?: Stripe.Checkout.SessionCreateParams.PaymentIntentData | undefined;
            payment_method_options?: Stripe.Checkout.SessionCreateParams.PaymentMethodOptions | undefined;
            payment_method_types?: Stripe.Checkout.SessionCreateParams.PaymentMethodType[] | undefined;
            phone_number_collection?: Stripe.Checkout.SessionCreateParams.PhoneNumberCollection | undefined;
            setup_intent_data?: Stripe.Checkout.SessionCreateParams.SetupIntentData | undefined;
            shipping_address_collection?: Stripe.Checkout.SessionCreateParams.ShippingAddressCollection | undefined;
            shipping_rates?: string[] | undefined;
            submit_type?: Stripe.Checkout.SessionCreateParams.SubmitType | undefined;
            subscription_data?: Stripe.Checkout.SessionCreateParams.SubscriptionData | undefined;
            tax_id_collection?: Stripe.Checkout.SessionCreateParams.TaxIdCollection | undefined;
        } | undefined) => Promise<CreateIntentResponse>;
        execute: (options: ExecuteOptions) => Promise<ExecuteIntentResponse>;
    };
};
