import { Mode, Gateway, Methods } from "../../gateway";
import { Stripe } from "stripe";
import { Items } from "../../items";
import { CheckoutConfiguration, CreateIntentResponse } from "./one-time";
export interface ExecuteOptions {
    body: any;
    signature?: string;
}
export interface ExecuteIntentResponse {
    status: boolean;
    method: Methods;
    mode: Mode;
    response: {
        invoice: Stripe.Response<Stripe.Invoice>;
        payment_intent?: Stripe.Response<Stripe.PaymentIntent>;
    };
}
export declare const EpicStripePaymentsSubscription: (Parent: Gateway<"Stripe">) => {
    new (configuration?: CheckoutConfiguration): {
        Instance: Stripe;
        Configuration?: CheckoutConfiguration | undefined;
        configure: (configuration: CheckoutConfiguration) => any;
        create: (Items: Items<"Subscription">, custom?: {
            cancel_url?: string | undefined;
            success_url?: string | undefined;
            after_expiration?: Stripe.Checkout.SessionCreateParams.AfterExpiration | undefined;
            allow_promotion_codes?: boolean | undefined;
            automatic_tax?: Stripe.Checkout.SessionCreateParams.AutomaticTax | undefined;
            billing_address_collection?: Stripe.Checkout.SessionCreateParams.BillingAddressCollection | undefined;
            client_reference_id?: string | undefined;
            consent_collection?: Stripe.Checkout.SessionCreateParams.ConsentCollection | undefined;
            customer?: string | undefined;
            customer_email?: string | undefined;
            customer_update?: Stripe.Checkout.SessionCreateParams.CustomerUpdate | undefined;
            discounts?: Stripe.Checkout.SessionCreateParams.Discount[] | undefined;
            expand?: string[] | undefined;
            expires_at?: number | undefined;
            line_items?: Stripe.Checkout.SessionCreateParams.LineItem[] | undefined;
            locale?: Stripe.Checkout.SessionCreateParams.Locale | undefined;
            metadata?: Stripe.MetadataParam | undefined;
            mode?: Stripe.Checkout.SessionCreateParams.Mode | undefined;
            payment_intent_data?: Stripe.Checkout.SessionCreateParams.PaymentIntentData | undefined;
            payment_method_options?: Stripe.Checkout.SessionCreateParams.PaymentMethodOptions | undefined;
            payment_method_types?: Stripe.Checkout.SessionCreateParams.PaymentMethodType[] | undefined;
            phone_number_collection?: Stripe.Checkout.SessionCreateParams.PhoneNumberCollection | undefined;
            setup_intent_data?: Stripe.Checkout.SessionCreateParams.SetupIntentData | undefined;
            shipping_address_collection?: Stripe.Checkout.SessionCreateParams.ShippingAddressCollection | undefined;
            shipping_rates?: string[] | undefined;
            submit_type?: Stripe.Checkout.SessionCreateParams.SubmitType | undefined;
            subscription_data?: Stripe.Checkout.SessionCreateParams.SubscriptionData | undefined;
            tax_id_collection?: Stripe.Checkout.SessionCreateParams.TaxIdCollection | undefined;
        } | undefined) => Promise<CreateIntentResponse>;
        execute: (options: ExecuteOptions) => Promise<ExecuteIntentResponse>;
    };
};
